#include <stdlib.h>
#include <time.h>
#include <stdio.h>

int moyenne(int tab[], size_t n) {
    size_t i;
    int res = 0;
    if (n > 0) {
	for (i=0; i<n; i++) res += tab[i];
	return ((double) res)/n; // Division relle!
    }
    fprintf(stderr, "Erreur : tableau de taille nulle!");
    return 0; // Il faut bien renvoyer une valeur.
}

int min(int tab[], size_t n) {
    size_t i;
    if (n > 0) {
	int min = tab[0];
	for (i=1; i<n; i++) 
	    if (tab[i] < min) min = tab[i];
	return min;
    }
    fprintf(stderr, "Erreur : tableau de taille nulle!");
    return 0; // Il faut bien renvoyer une valeur.
}

int print_positiv_only(int tab[], size_t n) {
    size_t i, count = 0;
    if (n > 0) {
	for (i=0; i<n; i++) {
	    if (tab[i] > 0) {
		printf("%d ",tab[i]);
		count++;
	    }
	}
    } else fprintf(stderr, "Erreur : tableau de taille nulle!");
    return count;
}


void randtab(int tab[], size_t n, int inf, int sup); 
void print_tab(int tab[], size_t n); // Cf. exercice /*@\ref{chap:types}.\ref{dyn_tab}@*/

#define TAB_SIZE 20
int main()
{
    int tab[TAB_SIZE];
    srand(time(NULL));
    randtab(tab,TAB_SIZE,-100,100);
    print_tab(tab, TAB_SIZE);
    printf("Valeurs positives : ");
    int p = print_positiv_only(tab, TAB_SIZE);
    printf("\nNombre de valeurs positives : %d\n", p);
    printf("Valeur minimale : %d\n", min(tab, TAB_SIZE));

    return 0;
}

void print_tab(int tab[], size_t n) {
    size_t i; 
    for (i=0; i<n; i++) printf("+----");
    if (n > 0) printf("+\n");
    for (i=0; i<n; i++) printf("| %2d ", tab[i]);
    if (n > 0) printf("|\n");
    for (i=0; i<n; i++) printf("+----");
    if (n > 0) printf("+\n");
}
     /* Remplit tab avec des valeurs alatoires comprises entre 0 et lim. */
void randtab(int tab[], size_t n, int inf, int sup) {
    size_t i;
    for (i=0; i<n; i++) 
	tab[i] = inf + (int) (((double) (sup+1-inf)) * rand() / (RAND_MAX+1.0));
}
