#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Renvoie 1 si mot est un palindrome, 0 sinon. */
int palindrome(char * mot) {
	size_t n = strlen(mot), i;
	for (i = 0; i <= n/2; i++) {
		if (mot[i] != mot[n-1-i]) return 0;
	}
	return 1;
}

int main(int argc, char * argv[])
{
	if (argc < 2) {
		printf("Usage: %s mot1 mot2...\n",argv[0]);
		return EXIT_FAILURE;
	}
	int i;
	for (i = 1; i < argc; i++)
		printf("Le mot \"%s\" %s un palindrome\n",
		       argv[i], palindrome(argv[i])?"est":"n'est pas");
	return 0;
}
