#include <stdio.h>
#include <stdlib.h>

#define FILEIN  "entree.txt"
#define FILEOUT "sortie.txt"

int main() 
{
    FILE *fi, *fo;
    int c;

    /* Ouverture du fichier FILEIN en lecture.   */
    if ( (fi = fopen(FILEIN, "r")) == NULL ) {
	perror("[Erreur] fopen (read)");
	return 1; 
    }
    /* Ouverture du fichier FILEOUT en criture. */
    if ( (fo = fopen(FILEOUT, "w")) == NULL ) {
	perror("[Erreur] fopen (write)");
	return 1; 
    }
    /* Recopie du contenu. */
    while (1) {
	c = getc(fi); // On ne teste pas les erreurs de lecture...
	if ( feof(fi) ) break;
	putc(c, fo);  // ... ni celles d'criture!
    }
    /* Fermeture des flots de donnees. */
    fclose(fi);
    fclose(fo);
    return 0;
}
