#include <stdio.h>

enum { LITTLE_ENDIAN, BIG_ENDIAN }; 

int get_endianess() {
    long i = 1;
    const char *p = (const char *) &i;
    if (p[0] == 1) return LITTLE_ENDIAN; // LSB correspond  1
    return BIG_ENDIAN;
}

int main()
{
    int n = get_endianess();
    printf("%s\n", (get_endianess() == LITTLE_ENDIAN)?"LITTLE_ENDIAN":"BIG_ENDIAN");
    return 0;
}
