#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"
#include "const-c.inc"

MODULE = Myst		PACKAGE = Myst		
INCLUDE: const-xs.inc

void
init(descr, a)
	FILE* descr = NO_INIT;
	int a;
  PREINIT:
	int fd;
        int val0;
        int val1;
  PPCODE:
	fd = init(a, &val0, &val1);
        if (fd == -1)
	        XSRETURN_UNDEF;
	descr = fdopen(fd, "r");
	if (descr == NULL) {
		close(fd);
	        XSRETURN_UNDEF;
	}
        {
		GV *gv = NULL;
		PerlIO *fp = NULL;
		if (SvOK(ST(0))) {
			gv = gv_fetchpv(SvPV_nolen(ST(0)), FALSE, SVt_PVCV);
		}
		if (gv == NULL) {
			fclose(descr);
			XSRETURN_UNDEF;
		}
	        fp = PerlIO_importFILE(descr,0);
        	if (fp != NULL &&
			do_open(gv, "+<&", 3, FALSE, 0, 0, fp) ) {
	        } else {
			fclose(descr);
		        XSRETURN_UNDEF;
		}
        }
	PUSHs(sv_2mortal(newSViv(val0)));
	PUSHs(sv_2mortal(newSViv(val1)));
