#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

/* Dfinir PTH_YIELD_UNDEF pour utiliser sur des systmes sans pthread_yield. */
#define NB_THREADS_FILS 4

pthread_mutex_t verrou;

void *unthread(void* x) {
        int i, *n = x;
	for (i = 0; i < 10; i++) {
		pthread_mutex_lock(&verrou);
		fprintf(stderr, "Thread %d au rapport: itration n%d\n", *n, i);
		pthread_mutex_unlock(&verrou);
#ifndef PTH_YIELD_UNDEF
		pthread_yield();
#endif
	}
	pthread_exit(NULL);
}

int main()
{
	pthread_t threads[NB_THREADS_FILS];
	int i, nums[NB_THREADS_FILS] = {0};
	pthread_mutex_init(&verrou, NULL);

	for (i = 0; i < NB_THREADS_FILS; i++) {
		nums[i] = i;
		pthread_create(&threads[i], NULL, unthread, &nums[i]);
	}

	for (i = 0; i < 10; i++) {
		if (i == 3)   pthread_mutex_lock  (&verrou);
		if (i == 7)   pthread_mutex_unlock(&verrou);
		fprintf(stderr, "Thread \"pre\" au rapport: itration n%d\n", i);
#ifndef PTH_YIELD_UNDEF
		pthread_yield();
#endif
	}

	for (i = 0; i < NB_THREADS_FILS; i++)
		pthread_join(threads[i], NULL);
	pthread_mutex_destroy(&verrou);
	return 0;
}
