#include <stdio.h>     
#include <netdb.h>

void check_servent(char * service, char * protocol) {
    struct servent * sp = getservbyname(service,protocol);
    if (sp == NULL) {
	fprintf(stderr, "Service %s avec le protocole %s introuvable\n",
		service,(protocol == NULL)?"NULL":protocol);
    } else {
	printf("Service %s \t- protocol %s - Port %d\n", 
	       sp->s_name, sp->s_proto, sp->s_port);
    }
}

int main( int argc, char* argv[]) 
{
    check_servent("domain", "udp"); // DNS avec udp: OK
    check_servent("ftp", "tcp");    // FTP avec tcp: OK
    check_servent("ftp", NULL);     // FTP avec tcp: OK
    check_servent("ftp", "udp");    // FTP avec udp: erreur (normalement!) /*@\label{network::getservbyname::ftp_udp}@*/
    return 0;
}

