#include <stdio.h>  // directive au prprocesseur 
#define TVA 15.0    // idem - dfinition de la TVA au Luxembourg

float prix_TTC;     // dclaration d'une variable globale/externe /*@\label{tva:ttc}@*/ 

// dclaration d'une fonction qui ajoute la TVA au prix HT et renvoie le prix TTC
float ajoute_TVA(float prix_HT) {             /*@\label{tva:ajoute_tva}@*/
	return prix_HT * (1.0 + (TVA/100.0));
}

// fonction main: point d'entree de l'excution 
int main()       /*@\label{tva:main}@*/
{
	float HT = 0.0;/*@\label{tva:interne}@*/ // dclaration d'une variable locale initialise  0

	printf("Entrez le prix H.T. : ");// appelle la fonction dfinie dans stdio.h
	scanf("%f",&HT);		 // idem
	prix_TTC = ajoute_TVA(HT);       // appel de notre fonction
	printf("prix T.T.C. : %.2f (TVA : %f%%)\n", prix_TTC, TVA);
	return 0;
}
