#include <stdio.h>
#include <complex.h>
#include <math.h>     // pour atan

int main()
{
	const double PI = 4*atan(1.0);   // astuce pour le calcul "exact" de /*@$\pi$@*/
	double complex z1 = 1.0 + I;     // construction classique 
	double complex z2 = cexp(I*PI);  // construction exponentielle; z2 = -1
	double complex z3 = conj(z1);    // conjugu: z3 = 1 - I
	double complex z4 = cpow(2,z1);  // calcul de /*@$2^{\mathtt{z_1}}$@*/
	printf("z1 = %f*exp(%fi)\n", cabs(z1), carg(z1)); // module/argument
	printf("z2 = %f +%fi\n",   creal(z2), cimag(z2)); // partie relle/imaginaire
	return 0;
}
