#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct correspondance {
	char pronom[15];  // je, tu, il ...
	char suffixe[4]; // e,  es, e ...
};

int main(int argc, char * argv[])
{
	if (argc != 2) {
		printf("usage: %s verbe\n",argv[0]);
		return EXIT_FAILURE;
	}
	size_t i, n = strlen(argv[1]); // n: nombre de caractres du verbe
	if ((n < 4) || (argv[1][n-2] != 'e') || (argv[1][n-1] != 'r')) {
		printf("Ce n'est pas un verbe du premier groupe!\n");
		return EXIT_FAILURE;
	}
	struct correspondance tab[] = { 
		{"je", "e"}, {"tu", "es"}, {"il ou elle", "e"}, 
		{"nous", "ons"}, {"vous", "ez"}, {"ils ou elles", "ent"}, 
	};
	char * base_verbe = (char *) malloc((n-2+1)*sizeof(char));
	strncpy(base_verbe, argv[1], n-2); // Recopie.
	base_verbe[n-2] = '\0'; // On ajoute le caractre NUL.
	for (i=0; i<sizeof(tab)/sizeof(struct correspondance); i++) 
		printf("%s %s%s\n", tab[i].pronom, base_verbe, tab[i].suffixe);
	return 0;
}





