#include <stdio.h>

struct jour {
    enum {CHAR_STATE, INT_STATE} indicateur; //indique l'tat de l'union
    union {
        char lettre;
        int numero;
    } day; // le champ day est une union sur un char et un int
};

    /* Affiche le contenu de la variable d, nomme name */
void affiche_jour(struct jour d, char * name) {
    switch (d.indicateur) {
       case CHAR_STATE: printf("%s = %c\n",name,d.day.lettre); break;
       case INT_STATE : printf("%s = %i\n",name,d.day.numero); break;
       default:         printf("erreur, union en tat inconnu!\n");
    }
}

int main() 
{
    struct jour ex1, ex2; //dclaration

    ex1.indicateur = CHAR_STATE;
    ex1.day.lettre = 'j';     
    affiche_jour(ex1, "ex1"); // affiche 'ex1 = j'
    ex2.indicateur = INT_STATE;
    ex2.day.numero = 4;
    affiche_jour(ex2, "ex2"); // affiche 'ex2 = 4'
    return 0;
}


