#include <stdio.h>

int main() {
    printf("|%d|\n", 14);                        // |14|
    printf("|%d|\n", -14);                       // |-14|
    printf("|%+d|\n",14);                        // |+14|
    printf("|%+d|\n",-14);                       // |-14|
    printf("|% d|\n",14);                        // | 14|
    printf("|% d|\n",-14);                       // |-14|
    printf("|%x|\n", 0x14ab);                    // |14ab|
    printf("|%X|\n", 0x14ab);                    // |14AB|
    printf("|%#x|\n",0x14ab);                    // |0x14ab|
    printf("|%#X|\n",0x14ab);                    // |0X14AB|
    
    printf("|%o|\n", 14);                        // |16|
    printf("|%#o|\n",14);                        // |016|
    
    printf("|%10d|\n",  14);                     // |        14|
    printf("|%10.4d|\n",14);                     // |      0014|
    printf("|%.4d|\n",  14);                     // |0014|
    printf("|%*.4d|\n", 10,14);                  // |      0014|
    printf("|%*.*d|\n", 10,4,14);                // |      0014|
    
    printf("|%f|\n",    1.234567890123456789e5); // |123456.789012|
    printf("|%.2f|\n",  1.234567890123456789e5); // |123456.79|
    printf("|%.20f|\n", 1.234567890123456789e5); // |123456.78901234567456413060|
    printf("|%20.2f|\n",1.234567890123456789e5); // |           123456.79|
    
    printf("|%e|\n",    1.234567890123456789e5); // |1.234568e+05|
    printf("|%.5e|\n",  1.234567890123456789e5); // |1.23457e+05|
    printf("|%.20e|\n", 1.234567890123456789e5); // |1.23456789012345674564e+05|
    printf("|%20.2e|\n",1.234567890123456789e5); // |            1.23e+05|
    
    printf("|%.5g|\n",1.234567890123456789e-5);  // |1.2346e-05|
    printf("|%.5g|\n", 1.234567890123456789e5);  // |1.2346e+05|
    printf("|%.5g|\n",1.234567890123456789e-3);  // |0.0012346|
    printf("|%.10g|\n",1.234567890123456789e5);  // |123456.789|

    return 0;
}
