#include <sys/time.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#undef  max
#define max(x,y) ((x) > (y) ? (x) : (y)) // Calcul du maximum.

void error(char * msg);      // Cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/.
int main()
{
	struct timeval delai = { 3, 500000 }; // Dlai de 3,5 secondes.
	fd_set desclecture;
	int max_desc = 0; // Le plus grand descripteur de l'ensemble desclecture.
	int desc_sock;
	// ... initialisation de desc_sock ...

	FD_ZERO(&desclecture);
	FD_SET(STDIN_FILENO, &desclecture);
	max_desc = max(max_desc, STDIN_FILENO); /* Pensez  mettre  jour
						   max_desc  chaque ajout!*/
	FD_SET(desc_sock, &desclecture);
	max_desc = max(max_desc, desc_sock);

	int r = select(max_desc+1, &desclecture, NULL, NULL, &delai);
	if (r < 0)  error("[select]");
	if (r == 0) printf("Aucune activit pendant la dure du dlai.\n");
	if (FD_ISSET(STDIN_FILENO, &desclecture))  // STDIN_FILENO prt en lecture.
		printf("La touche ENTREE a t presse.\n");
	if (FD_ISSET(desc_sock, &desclecture)) {
		// ... desc_sock est prte en lecture ...
	}
	return 0;
}

void error(char * msg) {
	perror(msg);
	exit(1);
}
